import * as React from 'react';
import { TreeNode } from './tree-node';
interface TableRowProps {
    node: TreeNode;
    level: number;
    selectedRow?: number;
    multiSelectedRows?: number[];
    collapsedNodes: number[];
    isCheckable: boolean;
    isClosable: boolean;
    getCheckedStatus: (id: number) => number;
    onToggleCollapse: (id: number) => void;
    onClose: (id: number) => void;
    onToggleCheck: (id: number) => void;
    onRowClick: (id: number) => void;
    onMultipleRowClick?: (id: number, isShiftClicked?: boolean) => void;
    onContextMenu: (event: React.MouseEvent<HTMLDivElement>, id: number) => void;
}
export declare class TableRow extends React.Component<TableRowProps> {
    constructor(props: TableRowProps);
    isCollapsed: () => boolean;
    private handleCollapse;
    private handleClose;
    renderToggleCollapse: () => React.ReactNode;
    renderCheckbox: () => React.ReactNode;
    renderCloseButton: () => React.ReactNode;
    renderRow: () => React.ReactNode;
    renderChildren: () => React.ReactNode | undefined;
    onClick: (e: React.MouseEvent<HTMLDivElement>) => void;
    onContextMenu: (event: React.MouseEvent<HTMLDivElement>) => void;
    render(): React.ReactNode | undefined;
}
export {};
//# sourceMappingURL=table-row.d.ts.map