import * as React from 'react';
import { ListRowProps, Index } from 'react-virtualized';
import { Experiment } from 'tsp-typescript-client/lib/models/experiment';
import { ITspClientProvider } from 'traceviewer-base/lib/tsp-client-provider';
export interface ReactOpenTracesWidgetProps {
    id: string;
    title: string;
    tspClientProvider: ITspClientProvider;
    contextMenuRenderer?: (event: React.MouseEvent<HTMLDivElement>, experiment: Experiment) => void;
    onClick?: (event: React.MouseEvent<HTMLDivElement>, experiment: Experiment) => void;
}
export interface ReactOpenTracesWidgetState {
    openedExperiments: Array<Experiment>;
    selectedExperimentIndex: number;
}
export declare class ReactOpenTracesWidget extends React.Component<ReactOpenTracesWidgetProps, ReactOpenTracesWidgetState> {
    static LIST_MARGIN: number;
    static LINE_HEIGHT: number;
    private _forceUpdateKey;
    private _sharingLink;
    private _showShareDialog;
    private _selectedExperiment;
    private _experimentManager;
    private _onExperimentOpened;
    private _onExperimentClosed;
    private _onExperimentDeleted;
    private _onOpenedTracesWidgetActivated;
    private _onTraceServerStarted;
    constructor(props: ReactOpenTracesWidgetProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    initialize(): Promise<void>;
    doHandleTraceServerStartedSignal(): Promise<void>;
    doHandleExperimentOpenedSignal(_experiment: Experiment): Promise<void>;
    protected doHandleExperimentClosed(experiment: Experiment): void;
    doHandleExperimentDeletedSignal(_experiment: Experiment): Promise<void>;
    protected doHandleTracesWidgetActivatedSignal(experiment: Experiment): void;
    protected doHandleContextMenuEvent(event: React.MouseEvent<HTMLDivElement>, traceUUID: string): void;
    protected dohandleClickEvent(event: React.MouseEvent<HTMLDivElement>, traceUUID: string): void;
    private getExperiment;
    render(): React.ReactNode;
    protected renderExperimentRow: (props: ListRowProps) => React.ReactNode;
    protected doRenderExperimentRow(props: ListRowProps): React.ReactNode;
    protected doHandleOnExperimentDeleted(e: React.MouseEvent<HTMLButtonElement>, traceUUID: string): void;
    protected renderTracesForExperiment(index: number): React.ReactNode;
    protected getRowHeight: (index: Index | number) => number;
    protected doGetRowHeight(index: Index | number): number;
    protected getTotalHeight(): number;
    protected renderSharingModal(): React.ReactNode;
    protected updateOpenedExperiments: () => Promise<void>;
    protected doUpdateOpenedExperiments(): Promise<void>;
    protected handleShareButtonClick: (index: number) => void;
    protected doHandleShareButtonClick(index: number): void;
    protected handleOnExperimentSelected: (e: React.MouseEvent<HTMLDivElement>) => void;
    protected handleContextMenuEvent: (e: React.MouseEvent<HTMLDivElement>, traceUUID: string) => void;
    protected handleClickEvent: (e: React.MouseEvent<HTMLDivElement>, traceUUID: string) => void;
    protected handleOnExperimentDeleted: (e: React.MouseEvent<HTMLButtonElement>, traceUUID: string) => void;
    protected doHandleOnExperimentSelected(e: React.MouseEvent<HTMLDivElement>): void;
    private selectExperiment;
    private updateSelectedExperiment;
    protected onWidgetActivated(experiment: Experiment): void;
    protected handleShareModalClose: () => void;
    protected doHandleShareModalClose(): void;
}
//# sourceMappingURL=trace-explorer-opened-traces-widget.d.ts.map