"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactExplorerPlaceholderWidget = exports.TraceResourceType = void 0;
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const React = __importStar(require("react"));
var TraceResourceType;
(function (TraceResourceType) {
    TraceResourceType["FOLDER"] = "Folder";
    TraceResourceType["FILE"] = "File";
})(TraceResourceType = exports.TraceResourceType || (exports.TraceResourceType = {}));
class ReactExplorerPlaceholderWidget extends React.Component {
    constructor(props) {
        super(props);
    }
    render() {
        return (React.createElement("div", { className: "placeholder-container", tabIndex: 0 },
            React.createElement("div", { className: "center" }, 'You have not yet opened a trace.'),
            this.renderButton(TraceResourceType.FOLDER, 'Open Trace Folder'),
            this.renderButton(TraceResourceType.FILE, 'Open Trace File')));
    }
    renderButton(type, title) {
        const btnTitle = type === TraceResourceType.FILE ? 'Select a single trace file to open' : 'Select a trace folder to open';
        return this.props.renderOnly === undefined || this.props.renderOnly === type ? (React.createElement("div", { className: "placeholder-open-workspace-button-container" },
            React.createElement("button", { className: "plcaeholder-open-workspace-button", title: btnTitle, onClick: () => this.props.handleOpenTrace(type), disabled: this.props.loading },
                this.props.loading && React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faSpinner, spin: true, style: { marginRight: '5px' } }),
                this.props.loading && React.createElement("span", null, "Connecting to trace server"),
                !this.props.loading && React.createElement("span", null, title)))) : undefined;
    }
}
exports.ReactExplorerPlaceholderWidget = ReactExplorerPlaceholderWidget;
//# sourceMappingURL=trace-explorer-placeholder-widget.js.map